<?php

	/****************************************
	 * Change the setting below if you like *
	 ****************************************/

	define("TRACE_MESSAGES", 0);
	define("TRACE_FILEPATH", "");
	define("MAX_RECORD_TO_DISPLAY", 500);	// only this much records will be shown in browser at one time to save hangups
	define("MAX_BLOB_LENGTH_CHECK", 100);	// blobs/text size larger than this, requires special handling
	define("SQL_EDITORTYPE", "codemirror");	// textarea = textarea, codemirror = codemirror syntax highlighting editor
	define("USE_MYSQLI", 1);				// if defined and set to 1, mysqli will be used (extension needs to be loaded also)
	define("THEME_PATH", "light");			// this can be overridden by user selection

	// at least one the two below should be defined. If USE_SENDMAIL is not defined or 0
	// mails would be done by directly connecting to an smtp server defined here instead
	// of using php mail() functions
	define("USE_SENDMAIL", 1);
	//define("SMTP_SERVER", "192.168.1.1");	// may require changing the user and pass below also!
	//define("SMTP_USERID", "samnan_akhoond@yahoo.com");
	//define("SMTP_PASSWORD", "abc");

	/****************************************
	 * You should not change anything below *
	 *  Unless you know what you are doing  *
	 ****************************************/

	define("EXTERNAL_PATH", str_replace(basename($_SERVER["SCRIPT_NAME"]), "", $_SERVER["SCRIPT_NAME"]));
	// bug reports will be sent to this email from the interface
	define("REPORT_EMAIL", "samnan_akhoond@yahoo.com");

	// below is required to adjust for serverside php configuration changes
	ini_set("display_errors", "off");

	include(dirname(__FILE__)."/auth.php");
	//include(dirname(__FILE__)."/database.php");
	include(dirname(__FILE__)."/keys.php");

	if (!function_exists('v'))
	{
		// this must be done only once, so it's here
		if (get_magic_quotes_gpc())
		{
			foreach ($_REQUEST as $k=>$v)
				$_REQUEST[$k] = stripslashes($v);
			foreach ($_POST as $k=>$v)
				$_POST[$k] = stripslashes($v);
			foreach ($_GET as $k=>$v)
				$_GET[$k] = stripslashes($v);
		}

		function v(&$check, $alternate = FALSE)
		{
			return (isset($check)) ? $check : $alternate;
		}
	}
?>