/********************************************************************
 *	options.js - Author: Samnan ur Rehman							*
 *	This file is a part of MyWebSQL package							*
 ********************************************************************/

function OptionsSave()
{
	for(i=0; i<arguments.length; i++)
	{
		arg = arguments[i];
		obj = document.getElementById(arg);
		if (obj)	// ! may warn user here that some options could not be saved
		{
			if (obj.type == "checkbox")
				val = obj.checked ? "on" : "";
			else
				val = obj.value;
			$.cookies.set("prf_"+arg, val, {path: EXTERNAL_PATH});
		}
	}

	jAlert("New settings saved and applied.");
}

function OptionsLoad()
{
	for(i=0; i<arguments.length; i++)
	{
		arg = arguments[i];
		obj = document.getElementById(arg);

		if (obj)
		{
			val = $.cookies.get("prf_"+arg);
			if (obj.type == "checkbox")
				obj.checked = val == "on" ? true : false;
			else
				obj.value = val;
		}
	}
}