<?php

	/********************************************************************
	*	html.php - Author: Samnan ur Rehman, Zeeshan Khan				*
	*	This file is a part of MyWebSQL package							*
	*	A really useful HTML generator class.							*
	*		A must use for all cool web developers ...					*
	*	PHP5 compatible													*
	*********************************************************************/

if (defined("CLASS_HTML_INCLUDED"))
	return true;

define("CLASS_HTML_INCLUDED", "1");
class html
{
	var $scriptText;	// collection of script text to send to browser
	var $focusID;		// item to set focus to when page loads
	var $preloadImages;	// images that should be preloaded in browser
	var $dir;			// direction of text (ltr = left to right, rtl = right to left)
	var $scriptFiles;

	function html()
	{
		$this->scriptText = array();
		$this->scriptFiles = array();
		$this->preloadImages = array();
		$this->focusID = false;
		$this->dir = "ltr";
	}

	function endhtml()
	{
		print("</html>\n");
	}
	function body($attrib="")
	{
		$body = "\n<body";
		if ($this->dir)
			$body .= " dir='$this->dir'";

		if($attrib != "")
			$body .= $attrib;

		$body .= " style='margin-top:0px;margin-left:0px;margin-right:0px;margin-bottom:0px'";
		$body .= ">";

		print "$body";
		//$this->scriptText("var _comboList = new Array();");
	}

	function frameset($rows="100%", $cols="100%")
	{
	  print "\n<frameset rows='$rows' cols='$cols'>";
	}

	function endframeset()
	{
		print "</frameset>";
	}

	//frame target src, frame attributesf
	function frame($src, $attr="")
	{
		$frame = "\n<frame src='$src'";
	  	if ($attr != "")
	  		$frame .= " $attr";

	  	$frame .= ">";
	  	print $frame;
	}

	//frame target src, frame attributes
	function iframe($src, $name, $attr="")
	{
		$frame = "\n<iframe src='$src'";
		$frame .= " name='$name'";

		if ($attr != "")
			$frame .= " $attr";

		$frame .= ">";
		print $frame;
	}

	function endiframe()
	{
		print "</iframe>";
	}

	function script($src, $language="javascript")
	{
		$path = '';
		$script = "\n<script ";
		if ($language == "")
			$script .= "language=javascript";
		else
			$script .= "language=\"$language\"";

		if(defined("SCRIPTS_PATH"))
			$path = SCRIPTS_PATH."/";

		$path .= $src;
		$script .= "type=\"text/$language\" src=\"$path\"></script>";
		if ($this->ajax)
			$this->scriptFiles[] = $path;
		else
			print $script;
	}

	function scriptText($text)
	{
		$this->scriptText[] = $text;
	}

	function theme($src)
	{
		$path='';
		$path .= $src;

		$theme = "<link rel=stylesheet href='$path' type='text/css'>";
		print $theme;
	}

	//form action, name , method
	function form($action, $name="", $method="", $windowName="", $encoding="", $extra="")
	{
		$form = "\n<form action=\"". "http://". SERVER_NAME . EXTERNAL_PATH . SCRIPT_NAME ."\"";

		if ($name != "")
		{
	 		$form .= " id=\"$name\"";
	 		$form .= " name=\"$name\"";
		}
	 	if ($method=="")
	 		$form .= " method=\"POST\"";
	 	else
	 		$form .= " method=\"$method\"";

	 	if($windowName != "")
			$form .= " target=\"$windowName\"";

		if($encoding != "")
			$form .= " enctype=\"$encoding\"";

		if($extra != "")
			$form  .= " $extra";

	 	$form .= ">";
		$form .= "\n<input type=hidden name=\"ACTION\" value=\"$action\">";


	 	print $form;
	}

	//form action, name , method
	function sform($action, $name="", $method="", $windowName="", $encoding="", $extra="")
	{
		$form = "\n<form action=\"". "https://". SERVER_NAME . EXTERNAL_PATH . SCRIPT_NAME ."\"";

		if ($name != "")
		{
	 		$form .= " id=\"$name\"";
	 		$form .= " name=\"$name\"";
		}

	 	if ($method=="")
	 		$form .= " method=\"POST\"";
	 	else
	 		$form .= " method=\"$method\"";

	 	if($windowName != "")
			$form .= " target=\"$windowName\"";

		if($encoding != "")
			$form .= " enctype=\"$encoding\"";

		if($extra != "")
			$form  .= " $extra";

	 	$form .= ">";
	 	$form .= "\n<input type=hidden name=\"ACTION\" value=\"$action\">";

	 	print $form;
	}

	function endform()
	{
	 	print "</form>";
	}
	// attributes, css class name, css style and id of enclosing span.
	function enclosedTable($attrib="", $class="", $style="",$spanId="",$spanWidth="0")
	{
		print "<span id=$spanId style='width:$spanWidth%'>";

		$this->table($attrib, $class, $style);
	}
	// attributes, css class name, css style
	function table($attrib="", $class="", $style="")
	{
		$table = "\n<table";
		if ($this->dir && $this->dir != "ltr")
			$table .= " dir='$this->dir'";

		if ($attrib != "")
			$table .= " $attrib cellspacing=\"0\" cellpadding=\"0\"";
		else
			$table .= " border=0 cellspacing=\"0\" cellpadding=\"0\"";

		if ($class != "")
			$table .= " class='$class'";
		else
			$table .= " class='deftable'";

		if ($style != "")
			$table .= " style='$style'";

		$table .= ">";
		print $table;
	}

	function caption($text, $attrib="", $class="defcaption", $style="")
	{
		$caption = "<caption";

		if ($attrib != "")
			$caption .= " $attrib";

		if ($class != "")
			$caption .= " class='$class'";

		if ($style != "")
			$table .= " style='$style'";

		$caption .= ">$text</caption>";

		print $caption;
	}

	function endEnclosedTable()
	{
		$this->endtable();
		print "</span>";
	}

	function endtable()
	{
		print "</table>";
	}

	function tr($attr="", $class="", $style="")
	{
		$tr = "\n<tr ";
		if ($attr != "")
			$tr .= "$attr";
		if ($class != "")
			$tr .= " class='$class'";
		if ($style != "")
			$tr .= " style='$style'";

		$tr .= ">";
		print $tr;
	}

	function endtr()
	{
	  print "</tr>";
	}

	function th($data="", $attr="", $class="", $style="")
	{
		$th = "\n<th ";
		if ($attr != "")
			$th .= "$attr";
		if ($class != "")
			$th .= " class='$class'";
		else
			$th .= " class='defth'";

		if ($style != "")
			$th .= " style='$style'";

		$th .= ">";
		if ($data != "")
			$th .= "$data</th>";

		print $th;
	}

	function endth()
	{
		print "</th>";
	}

	function td($data="", $attr="", $class="", $style="")
	{
		$td = "\n<td ";
		if ($attr != "")
			$td .= "$attr";
		if ($class != "")
			$td .= " class='$class'";
		else
			$td .= " class='deftd'";
		if ($style != "")
			$td .= " style='$style'";
		if ($data != "")
			$td .= ">$data</td>";
		else
			$td .= ">";
		print $td;
	}

	function endtd()
	{
		print "</td>";
	}


	function font($text="",$attrib="",$class="",$style="")
	{
		$font = "<font ";

		if($attrib != "")
			$font .= $attrib;

		if($class != "")
			$font .= $class;

		if($style != "")
			$font .= $style;

		if($text != "")
			$font .= ">$text </font>";
		else
			$font = ">";

		print $font;
	}

	function endfont()
	{
		print "</FONT>";
	}

	function link($target="", $value, $attr="", $class="default", $style="")
	{
		$link = "<a ";
		if ($target != "")
			$link .= "href=\"$target\"";
		if (is_array($attr))
			foreach($attr as $key=>$val)
				$link .= " $key=\"".htmlspecialchars($val). "\"";
		else if ($attr != "")
			$link .= " $attr";
		if ($class != "")
			$link .= " class='$class'";
		if ($style != "")
			$link .= " style='$style'";
		if($value != "")
		{
			$link .= ">$value";
			$link .= "</a>";
		}
		else
			$link .= ">";
		print $link;
	}

	function endlink()
	{
		print "</a>";
	}

	function imglink($target="", $value, $image, $attr="", $class="", $style="")
	{
		$link = "<a";
		if($target != "")
			$link .= " href=\"$target\"";
		if (is_array($attr))
			foreach($attr as $key=>$val)
				$link .= " $key=\"".htmlspecialchars($val). "\"";
		else if ($attr != "")
			$link .= " $attr";
		if ($class != "")
			$link .= " class='$class'";
				if ($style != "")
			$link .= " style='$style'";

		if (defined("IMAGES_PATH"))
			$image = IMAGES_PATH . $image;
		$link .= "><img border=\"0\" alt=\"\" align=\"middle\" src='$image'>";
		if($value != "")
			$link .= "&nbsp;$value";
		$link .= "</a>";
		print $link;
	}

	function select($name, $attr="", $class="", $style="")
	{
		$select = "\n<select dir=\"$this->dir\" name='$name'";
		if ($attr != "")
			$select .= " $attr";

		if ($class == "")
			$select .= " class='defselect'";
		else
			$select .= " class='$class'";

		if ($style != "")
			$select .= " style='$style'";

		$select .= ">";
		print $select;
	}

	function endselect()
	{
		print "</select>";
	}

	function option($val, $data,$attr="")
	{
		print "\n<option value=\"".htmlspecialchars($val)."\" $attr>".htmlspecialchars($data)."</option>";
	}

	function dateCombo($name, $defVal, $start, $end, $attr="", $style="", $class="defselect")
	{
		$datecombo = "<select dir=\"$this->dir\" name='$name' $attr style='$style' class='$class'>";
		$datecombo .= "\n<option value='' selected></option>";

		for ($iLoop = $start; $iLoop <= $end; $iLoop++)
		{
			if ($iLoop < 10)
				$val = "0" . $iLoop;
			else
				$val = $iLoop;

			$datecombo .= "\n<option value = '$val'";

			if ($val == $defVal)
				$datecombo .= " selected";

			$datecombo .= "> $val </option>";
		}

		$datecombo .= "\n</select>";

		print $datecombo;
	}

	///defaultdate format is dd-mm-yyyy
	function dateBox($dd, $mm, $yy, $arr="")
	{
		$defaultdate = trim($arr["defaultdate"]);
		$class = trim($arr["class"]);
		$start = trim($arr["start"]);
		$end = trim($arr["end"]);
		$attr = trim($arr["attr"]);
		$style = trim($arr["style"]);
		$monthFormat = intval(trim($arr["monthformat"]));
		$yearorder = trim($arr["yearorder"]);

		if ($monthFormat == 1)
			$MONTHS = array ("","Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
		if ($start == "")
			$start = "1920";
		if ($end == "")
			$end = date("Y");
		if ($class == "")
			$class = "defselect";

		if ($defaultdate == "" || $defaultdate == "--" || $defaultdate == "//")
		{
			$datebox = "<select name='$dd' $attr style='width:52px$style' class='$class'>";
			$datebox .= "\n<option value='' selected></option>";

			for ($iLoop = 1; $iLoop < 32; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				$datebox .= "\n<option value = '$val'> $val </option>";
			}

			$datebox .= "\n</select><select dir=\"$this->dir\" name='$mm' $attr style='width:52px$style' class='$class'>";
			$datebox .= "\n<option value='' selected></option>";

			for ($iLoop = 1; $iLoop < 13; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($monthFormat == 1)
					$data = $MONTHS[$iLoop];
				else
					$data = $val;

				$datebox .= "\n<option value = '$val'> $data </option>";
			}

			$datebox .= "</select><select dir=\"$this->dir\" name='$yy' $attr style='width:60px$style' class='$class'>";
			$datebox .= "\n<option value='' selected></option>";

			if ($yearorder == "0")
			{
				for ($iLoop = $end; $iLoop >= $start; $iLoop--)
				{
					$val = $iLoop;

					$datebox .= "\n<option value = '$val'> $val </option>";
				}
			}
			else
			{
				for ($iLoop = $start; $iLoop <= $end; $iLoop++)
				{
					$val = $iLoop;

					$datebox .= "\n<option value = '$val'> $val </option>";
				}
			}

			$datebox .= "</select>";

			print $datebox;
		}
		else
		{
			$defdate = substr($defaultdate, 0, 10);
			if (!strstr($defdate, "-"))
				$token = "/";
			else
				$token = "-";

			$arr = split($token, $defdate);

			$defdd = $arr[0];
			$defmm = $arr[1];
			$defyy = $arr[2];

			if (strlen(trim($arr[0])) == 4)
			{
				$defdd = $arr[2];
				$defyy = $arr[0];
			}

			$datebox = "<select dir=\"$this->dir\" name='$dd' $attr style='width:52px$style' class='$class'>";

			for ($iLoop = 1; $iLoop < 32; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($val == $defdd)
					$datebox .= "<option value = '$val' selected> $defdd </option>";

				else
					$datebox .= "\n<option value = '$val'> $val </option>";
			}

			$datebox .= "</select><select dir=\"$this->dir\" name='$mm' $attr style='width:52px$style' class='$class'>";

			for ($iLoop = 1; $iLoop < 13; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($monthFormat == 1)
					$data = $MONTHS[$iLoop];
				else
					$data = $val;

				if ($val == $defmm)
					$datebox .= "<option value = '$val' selected> $data </option>";

				else
					$datebox .= "\n<option value = '$val'> $data </option>";
			}

			$datebox .= "</select><select dir=\"$this->dir\" name='$yy' $attr style='width:60px$style' class='$class'>";


			if ($yearorder == "0")
			{
				for ($iLoop = $end; $iLoop >= $start; $iLoop--)
				{
					$val = $iLoop;
					if ($val == $defyy)
						$datebox .= "<option value ='$val' selected>$defyy</option>";
					else
						$datebox .= "\n<option value = '$val'> $val </option>";
				}
			}
			else
			{
				for ($iLoop = $start; $iLoop <= $end; $iLoop++)
				{
					$val = $iLoop;
					if ($val == $defyy)
						$datebox .= "<option value ='$val' selected>$defyy</option>";
					else
						$datebox .= "\n<option value = '$val'> $val </option>";
				}
			}


			$datebox .= "</select>";

			print $datebox;
		}
	}

	function timeBox($hh, $mm, $ss, $defaulttime="", $disable="")
	{
		if ($defaulttime == "")
		{
			$timebox = "<select dir=\"$this->dir\" name='$hh' $disable style='width:52px'>";
			$timebox .= "\n<option value='' selected></option>";

			for ($iLoop = 0; $iLoop < 24; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "\n</select>&nbsp;<SELECT dir=\"$this->dir\" name='$mm' $disable style='width:52px'>";
			$timebox .= "\n<option value='' selected></option>";

			for ($iLoop = 0; $iLoop < 60; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>&nbsp;<select dir=\"$this->dir\" name='$ss'  $disable style='width:52px'>";
			$timebox .= "\n<OPTION value='' selected></option>";

			for ($iLoop = 0; $iLoop < 60; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>";

			print $timebox;
		}
		else
		{
			$deftime = substr($defaulttime, 0, 8);
			$defhh = substr($deftime, 0, 2);
			$defmm = substr($deftime, 3, 2);
			$defss = substr($deftime, 6, 2);

			$timebox = "<select dir=\"$this->dir\" name='$hh' $disable style='width:52px'>";

			for ($iLoop = 0; $iLoop < 24; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($val == $defhh){
					$timebox .= "<option value = '$val' selected> $defhh </OPTION>";}

				else
					$timebox .= "\n<option value = '$val'> $val </OPTION>";
			}

			$timebox .= "</select>&nbsp;<select dir=\"$this->dir\" name='$mm' $disable style='width:52px'>";

			for ($iLoop = 0; $iLoop < 60; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($val == $defmm){
					$timebox .= "<option value = '$val' selected> $val </option>";}

				else
					$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>&nbsp;<select dir=\"$this->dir\" name='$ss' $disable style='width:52px'>";

			for ($iLoop = 0; $iLoop < 60; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($val == $defss){
					$timebox .= "<option value ='$val' selected>$defss</option>";}

				else
					$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>";

			print $timebox;
		}
	}

	function input($type, $name, $value="", $attr="", $class="", $style="")
	{
	  	$input = "\n<input dir=ltr type='$type' name='$name'";
	  	if ($value != "")
	  	 	$input .= " value=\"" . htmlspecialchars($value) . "\"";

		if($this->ajax && ($type == "button" || $type == "submit"))
		{
			if(!in_array($name, $this->buttonList))
			{
				$this->input("hidden", "selected_". $this->currForm ."_$name");
				$this->buttonList[] = $name;
			}

			if ($this->currForm)
			{
				if ($attr != "")
				{
					$tempStr = strtolower($attr);
					$startPos =	strpos($tempStr, "onclick=") + 8;

					if($pos > -1)
						$input .= " ". substr($attr, 0, $startPos) + "document.". $this->currForm .".selected_". $this->currForm ."_$name.value = '$value'; " + substr($attr, $startPos + 1, strlen($attr) - $startPos);
					else
						$input .= " $attr onclick=\"document.". $this->currForm .".selected_". $this->currForm ."_$name.value = '$value';\"";
				}
				else
					$input .= " onclick=\"document.". $this->currForm .".selected_". $this->currForm ."_$name.value = '$value';\"";
			}
			else if ($attr != "")
				$input .= " $attr";
		}
		else if ($attr != "")
			$input .= " $attr";

		if ($class == "")
		{
			if (($type == "button") || ($type == "submit"))
				$input .= " class='defbutton'";

			if (($type == "text") || ($type == "password"))
				$input .= " class='deftext'";

			if (($type == "radio") || ($type == "check"))
				$input .= " class='defradio'";
		}
		else
			$input .= " class='$class'";

		if ($style != "")
			$input .= " style='$style'";

		$input .= ">";

		print $input;
	}

	function endinput()
	{
		print "</input>";
	}

	function textarea($name="",$value="",$attr="",$class="",$style="")
	{
		$textarea = "<textarea name='$name'";
		if ($attr !="")
		{
			$textarea .= " $attr";
		}
		if ($class !="")
		{
			$textarea .= " class='$class'";
		}
		else
			$textarea .= " class='deftextarea'";
		if ($attr !="")
		{
			$textarea .= " style='$style'";
		}
		$textarea .= ">";

		if($value!="")
			$textarea .= $value;

		$textarea .= "</textarea>";
		print $textarea;

	}

	function line($msg)
	{
		print "\n$msg<br/>";
	}

	function newline($times=1)
	{
		if ($times == 1)
			print "<br/>";
		else
			print str_repeat("<br/>", $times);
	}

	function text($msg)
	{
		print $msg;
	}

	function label($text, $id, $attr="")
	{
		$label = "<label style='cursor:hand' for='$id'";

		if ($attr != "")
			$label .= " $attr";

		$label .= ">$text</label>";

		print $label;
	}

	function div($attr="", $class="", $style="")
	{
		$div = "\n<div";

		if ($attr != "")
			$div .= " $attr";

		if ($class != "")
		  	$div .= " class='$class'";

		if ($style != "")
			$div .= " style='$style'";

		$div .= ">";
		print $div;
	}

	function enddiv()
	{
		print "</div>";
	}

	function span($class="", $style="",$attr="")
	{
		$span = "\n<span";
	 	if ($class != "")
	 		$span .= " class='$class'";

	 	if ($style != "")
	 		$span .= " style='$style'";

	 	$span .= " $attr>";
	 	print $span;
	}

	function endspan()
	{
		print "</span>";
	}

	function hr($attr="", $class="", $style="")
	{
	  	$hr = "\n<hr";
	  	if ($attr != "")
	  		$hr .= " $attr";
	  	if ($class != "")
	  		$hr .= " class='$class'";
	  	if ($style != "")
	  		$hr .= " style='$style'";

	  	$hr .= ">";
	  	print $hr;
	}

	function ul($class="", $style="")
	{
		$ul = "\n<ul";
		if ($class != "")
			$ul .= " class='$class'";
		if ($style != "")
			$ul .= " style='$style'";
		$ul .= ">";
	  	print $ul;
	}

	function endul()
	{
	    print "</UL>";
	}

	function ol($start="", $class="", $style="")
	{
	  	$ol = "\n<ol";
	  	if ($start != "")
	  		$ol .= " start='$start'";
	  	if ($class != "")
	  		$ol .= " class='$class'";
	  	if ($style != "")
	  		$ol .= " style='$style'";

	  	$ol .= ">";
	  	print $ol;
	}

	function endol()
	{
	    print "</ol>";
	}

	function li($msg, $value="", $class="", $style="")
	{
	  	$li = "\n<li";
	  	if ($value != "")
	  		$li .= " value='$value'";
	  	if ($class != "")
	  		$li .= " class='$class'";
	  	if ($style != "")
	  		$li .= " style='$style'";

	  	$li .= "> $msg";
	  	print $li;
	}

	function comment($txt)
	{
		print "<!--$txt-->";
	}

	function timeBox2($hh, $mm, $defaulttime="", $disable="")
	{
		if ($defaulttime == "")
		{
			$timebox = "<select dir=\"$this->dir\" name='$hh' $disable style='width:52px'>";
			$timebox .= "\n<option value='' selected></option>";

			for ($iLoop = 0; $iLoop < 24; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "\n</select>&nbsp;<select dir=\"$this->dir\" name='$mm' $disable style='width:52px'>";
			$timebox .= "\n<option value='' selected></option>";

			for ($iLoop = 0; $iLoop < 60; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>";

			print $timebox;
		}
		else
		{
			$deftime = substr($defaulttime, 0, 8);
			$defhh = substr($deftime, 0, 2);
			$defmm = substr($deftime, 3, 2);

			$timebox = "<select dir=\"$this->dir\" name='$hh' $disable style='width:52px'>";

			for ($iLoop = 0; $iLoop < 24; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($val == $defhh){
					$timebox .= "<option value = '$val' selected> $defhh </option>";}

				else
					$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>&nbsp;<select dir=\"$this->dir\" name='$mm' $disable style='width:52px'>";

			for ($iLoop = 0; $iLoop < 60; $iLoop++)
			{
				if ($iLoop < 10)
					$val = "0" . $iLoop;
				else
					$val = $iLoop;

				if ($val == $defmm){
					$timebox .= "<option value = '$val' selected> $val </option>";}

				else
					$timebox .= "\n<option value = '$val'> $val </option>";
			}

			$timebox .= "</select>";

			print $timebox;
		}
	}

	function image($name="", $link="",$attr="",$class="",$style="", $common=1) //common will indicate shared path, i.e. common or language dependent.
	{
		if (defined("IMAGES_PATH"))
		{
			if ($common == 0)
				$imgtext = "<img src='".IMAGES_PATH."/$name'";
			else
				$imgtext = "<img src='".COMMON_IMAGES_PATH."/$name'";
		}
		else
			$imgtext = "<img src='$name'";

		if ($attr != "")
			$imgtext .= " $attr";
		if ($class != "")
			$imgtext .= " class='$attr'";
		if ($style != "")
			$imgtext .= " style='$style'";
		$imgtext .= ">";

		print $imgtext;

	}

	function icon($name="",$link="",$attr="",$class="",$style="", $common=1) //common will indicate shared path, i.e. common or language dependent.
	{
		if (defined("IMAGES_PATH"))
		{
			if ($common == 0)
				$icontext = "<img align=middle src='".IMAGES_PATH."/small/$name'";
			else
				$icontext = "<img align=middle src='".COMMON_IMAGES_PATH."/small/$name'";
		}
		else
			$icontext = "<img align=middle src='/small/$name'";

		if ($attr != "")
			$icontext .= " $attr";
		if ($class != "")
			$icontext .= " class='$attr'";
		if ($style != "")
			$icontext .= " style='$style'";
		$icontext .= ">";

		print $icontext;
	}

	function infoText($text,$help, $tipQuote=true)
	{
		$help = str_replace("'","\'",$help);

		traceMessage("html showTips is ". $this->showTips);
		if ($this->showTips)
		{
			$help=str_replace(";","",$help);
			print "\n<span class='infotext' style=\"cursor:default\" ";
			if (!$tipQuote)
				print "onmouseover=\"showTip($help,this)\"";
			else
				print "onmouseover=\"showTip('$help',this)\"";
			print "onmouseout=\"hideTip()\">";
			$this->icon("infotext.gif", "", "align=middle");
			print "&nbsp;$text</span>";
		}
		else
			$this->text($text);
	}

	function setDefaultField($fieldName)
	{
		$this->focusID = "document." . $fieldName;
	}

	function preloadImage($imgpath)
	{
		$this->preloadImages[] = $imgpath;
	}

	function endbody($ver="",$browser="")
	{
		foreach($this->preloadImages as $t)
				$this->text("\n<img src='$t' alt=\"\" style='display:none'>");

		$js = "";

		if ($this->focusID)
		{
			$id = $this->focusID;
			$js .= $id . ".focus();\n";
		}

		$this->scriptText($js);

		if (count($this->scriptText) > 0)
			$this->generateScriptText(); // generates the text for java script

		if ($ver == "")
			$ver = 0;

		$this->text("</body></html>");
	}

	// generates the text in scriptText for java script.
	function generateScriptText()
	{
		$this->text("<script type=\"text/javascript\" language=\"javascript\">");

		foreach($this->scriptText as $t)
			$this->text("$t;");

		$this->scriptText = array(); // flush the array.
		$this->text("</script>");
	}

	function generateScriptFileTag()
	{
		if(is_array($this->scriptFiles) && count($this->scriptFiles) > 0)
		{
			foreach($this->scriptFiles as $file)
				print "<SCRIPTFILES><![CDATA[$file]]></SCRIPTFILES>";
		}
	}
	function getScriptText()
	{
		$text = "";
		foreach($this->scriptText as $t)
			$text .= $t;
		return  $text;
	}

    function id($str)
    {
        return str_replace(array(' ', '\'', '"'), '_', $str);
    }
	// additional functions, mostly specific to the application should be added here.
}

?>