<?php

	/********************************************************************
	*	bugreport.php - Author: Samnan ur Rehman						*
	*	This file is a part of MyWebSQL package							*
	*	PHP5 compatible													*
	*********************************************************************/

	function processRequest(&$db)
	{
		// html and form is started by calling function
		print "<link href='cache.php?css=default' rel=\"stylesheet\" />\n";
		print "<div class='scrinfo'>";
		if (saveBugReport())
			print "Thank you for submitting the bug report. We will take a look at it and fix it in the upcoming version for you, as soon as possible. Please be patient !";
		else
			displayBugForm();
		print "</div>";
		
		print "<script type=\"text/javascript\" language='javascript'> parent.updatePopupTitle('Bug report');
		if(document.frmquery.browser)
		{
			document.frmquery.browser.value = parent.browser.name;
			document.frmquery.browser.value += ' ' + parent.browser.version;
		}
		</script>";
	}
	
	function displayBugForm()
	{
		print "<input type='hidden' name='type' value='bugreport' />";
		print "<table border=0 cellspacing=2 cellpadding=2 width=\"100%\">";
		print "<tr><td>Short description:</td><td><input type='text' size=30 name='bug' value='' /></td></tr>";
		print "<tr><td>My browser and version is:</td><td><input type='text' size=30 name='browser' value='' /></td></tr>";
		print "<tr><td>My Email Address (optional):</td><td><input type='text' size=30 name='email' value='' /></td></tr>";
		print "<tr><td colspan=2>Please describe the problem, and what actions you performed that resulted in the problem</td></tr>";
		print "<tr><td><input type='hidden' name='id' value='' /></td></tr>";
		print "<tr><td colspan=2 align=right><textarea cols=60 rows=6 name='bugdetails'></textarea></td></tr>";
		print "<tr><td colspan=2 style=\"text-align:right\"><input type='submit' name='btn' value='   Submit   ' onclick='document.frmquery.submit();'/></td></tr>";
		print "<script type=\"text/javascript\" language='javascript'> if (document.frmquery.bug) document.frmquery.bug.focus(); </script>";
	}
	
	function saveBugReport()
	{
		if (isset($_REQUEST["bug"]) && isset($_REQUEST["bugdetails"]))
		{
			include("lib/maillib.php");	// validate email function is inside the lib
			$bug = trim($_REQUEST["bug"]);
			$details = trim($_REQUEST["bugdetails"]);
			$browser = trim($_REQUEST["browser"]);
			$user_email = v($_POST["email"]) && is_valid_email($_POST["email"]) ? $_POST["email"] : REPORT_EMAIL;
			if ($bug && $details)
			{
				// email bug
				$subject = "PRJ:MyWebSql#BugReport";
				$mailMsg = "<html><body>Title:".htmlspecialchars($bug)."<hr width='100%'></hr>Browser: ".htmlspecialchars($browser)."<hr width='100%'></hr>".htmlspecialchars($details)."</body></html>";
				$mailOBJ = new CMailFile($subject, REPORT_EMAIL, $user_email, $mailMsg, NULL);
				$mailOBJ->content_type = "text/html";
				if(!$mailOBJ->sendfile())
				{
					debugLog("Failed to send bug report.$bug");
					debugLog($details);
				}
				return true;
			}
		}
		
		return false;
	}
	
?>