<?php

	/******************************************************
	* createtbl.php - Author: Samnan ur Rehman            *
	* This file is a part of MyWebSQL package             *
	* PHP5 compatible                                     *
	******************************************************/

	function processRequest(&$db)
	{
		// html and form is started by calling function
		print "<link href='cache.php?css=theme,default,theme,results' rel=stylesheet />\n";
		print "<script type=\"text/javascript\" language='javascript' src='cache.php?script=common,jquery,tables,browser,position,query'></script>\n";
		print "<div class='scrinfo'>";
		
		$type = "warning";
		if (v($_REQUEST["objinfo"]))
		{
			$msg = createDatabaseTable($db, $_REQUEST["id"], $_REQUEST["objinfo"]);
			if (!$msg)		// msg will be returned only if error (bad programming guys, dont learn from it !)
			{
				$msg = "The command executed successfully.";
				$type = "notice";
			}
			else
				$type="error";
		}
		else
		{
			$msg = "";
			displayCreateTableForm($msg);
		}
		print "</div>";
		
		print "<script type=\"text/javascript\" language='javascript'> parent.updatePopupTitle('Create new table');";
		includE('config/keys.php');
		foreach($KEY_CODES as $name=>$code)
			echo "\t".'var '.$name.' = "'.$code[0].'";'."\n";
		print "\n</script>";
	}
	
	function displayCreateTableForm($msg, $type="warning")
	{
		if ($msg)
		{
			$icon = $type == 'warning' || $type == 'notice' ? 'ui-icon-info' : 'ui-icon-error';
			$div = '<div class="ui-widget ui-state-highlight ui-corner-all" style="padding:2px"><span class="ui-icon '.$icon.'"></span>'.$msg.'</div>';
		}
		else
			$div = '';
	
		print "<input type='hidden' name='q' value='wrkfrm' />";
		print "<input type='hidden' name='type' value='createtbl' />";
		print "<input type='hidden' name='id' value='".v($_REQUEST["id"])."' />";
		print "<table border=0 cellspacing=2 cellpadding=2>";
		print "<tr><td>$div</td></tr>";
		print "<tr><td colspan=2 align=right>";
		
		print "<table class='sortable' border=0 cellspacing=1 cellpadding=2 width='100%' id='table_grid'><tbody>";
		print "<tr id='fhead'><th class='th'>Field Name</th><th class='th'>Data Type</th><th class='th'>Length</th><th class='th'>Default value</th><th class='th'>Unsigned</th><th class='th'>Zero Fill</th><th class='th'>Primary Key</th><th class='th'>Not NULL</th></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "<tr class='row'><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td><td class='tl edit'>&nbsp;</td></tr>";
		print "</tbody></table>";
		
		print "</td><tr>";
		
		print "<tr><td colspan=2 align=right><input type='submit' name='btn' value='   Submit   ' onclick='return createTableInfo()'/></td></tr>";
		print "</table>";

		$field_list = array(
				array('name'=>'Field Name', 'type'=>'char', 'not_null'=>TRUE),
				array('name'=>'Data Type', 'type'=>'list', 'not_null'=>TRUE),
				array('name'=>'Length', 'type'=>'numeric', 'not_null'=>TRUE),
				array('name'=>'Default Value', 'type'=>'char', 'not_null'=>TRUE),
				array('name'=>'Unsigned', 'type'=>'list', 'not_null'=>TRUE),
				array('name'=>'Zerofill', 'type'=>'list', 'not_null'=>TRUE),
				array('name'=>'Primary Key', 'type'=>'list', 'not_null'=>TRUE),
				array('name'=>'Not NULL', 'type'=>'list', 'not_null'=>TRUE)
			);
		foreach($field_list as $field)
		{
			$f = new StdClass;
			$f->name = $field['name'];
			$f->type = $field['type'];
			$fields[] = $f;
		}
		$fieldInfo = json_encode($fields);

		print "<script type=\"text/javascript\" language='javascript'> fieldInfo = ".$fieldInfo.";\n setupTable('table_grid', {highlight:true,editable:true,editEvent:'click',editFunc:editTableField}); </script>";
	}
	
	function createDatabaseTable(&$db, $id, $info)
	{
		// create command from grid data
		$cmd = 'create table test';
		if (!$db->query($cmd))
			return htmlspecialchars($db->getError());
		
		return "";
	}


?>