<?php

	/********************************************************************
	*	viewblob.php - Author: Samnan ur Rehman							*
	*	This file is a part of MyWebSQL package							*
	*	PHP5 compatible													*
	*********************************************************************/

	function processRequest(&$db)
	{
		// this function is optimizable ..
		// by reducing the number of queries and the actual query that brings blob data, db server will be happier
		traceMessage("viewBlob...");

		// contents of the iframe inside popup
		startForm("overflow:auto");
		print "<link href='cache.php?css=default' rel=\"stylesheet\" /><script type=\"text/javascript\" language='javascript' src='js/blobs.js'></script>";

		print "<div class='scrinfo' style='width:100%'>\n";
		$query = $_SESSION["query"];
		$id = $_REQUEST["id"];
		$name = $_REQUEST["name"];

		include("config/blobs.php");
		$bType =  ( array_key_exists($_REQUEST["blobtype"], $blobTypes) ) ? $_REQUEST["blobtype"] : "txt";

		if ($_SESSION["table"] == "")	// the query is probably desc, or show create table etc, so we can apply limit
			$applyLimit = true;
		else
			$applyLimit = strpos($query, "limit ");

		if ($applyLimit == false)
			$query .= " limit $id, 1";

		if ($db->query($query))
		{
			$row = ($applyLimit==false ? $db->fetchRow() : $db->fetchSpecificRow($id));

			// show as image etc ...
			if ($bType && v($_REQUEST["show"]) && $blobTypes[$bType][2])
			{
				header($blobTypes[$bType][2]);
				ob_end_clean();
				print $row[$name];
				return true;
			}

			print "<div style='width:100%;height:20px'>";

				print "<div style='float:left'>Data for column $name</div>";
				print "<div style='float:right;margin-right:20px'>Show blob data as:&nbsp;&nbsp;<select name='blobtype' onchange=\"blobChangeType('$id', '$name')\"></div>";

				foreach($blobTypes as $k=>$v)
				{
					if ($bType == $k)
						print "<option value='$k' selected=\"selected\">$v[0]</option>\n";
					else
						print "<option value='$k'>$v[0]</option>\n";
				}
				print "</select></div>";

			print "</div>";


			print "<div style='width:100%'><hr width='100%' class='hr'></div>";
			print "<div style='width:100%'><pre class='blob'>";

			// try to show the blob data as specified type
			if ($bType && $blobTypes[$bType] && v($blobTypes[$bType][3]))
			{
				if (strpos($blobTypes[$bType][3], "#link#") !== false)
					print str_replace("#link", "?q=wrkfrm&type=viewblob&show=1&id=$id&name=$name&blobtype=$bType", $blobTypes[$bType][3]);
				//else if (strpos($blobTypes[$bType][3], "#src#") !== false)
				//	print str_replace("#src", $row[$name], $blobTypes[$bType][3]);
				else
					print htmlspecialchars($row[$name]);
			}
			else if ($bType && $blobTypes[$bType] && v($blobTypes[$bType][4]))
			{
				$func = $blobTypes[$bType][4];
				print htmlspecialchars(print_r($func($row[$name]), 1));
			}
			else
				print htmlspecialchars($row[$name]);

			print "</pre></div>";

		}

		print ("<script type=\"text/javascript\" language='javascript'> parent.transferBlobData(); </script>\n");
		print "</form></div></body></html>";
	}
	
?>