<?php

	/********************************************************************
	*	processes.php - Author: Samnan ur Rehman						*
	*	This file is a part of MyWebSQL package							*
	*	PHP5 compatible													*
	*********************************************************************/

	function processRequest(&$db)
	{
		// html and form is started by calling function
		print "<link href='cache.php?css=default,theme,results' rel=stylesheet />\n";
		print "<script type=\"text/javascript\" language='javascript' src='cache.php?script=jquery,sorttable,tables'></script>\n";
		//print "<div class='scrinfo' style='width:99%'>";
		
		if (isset($_REQUEST["processid"]))
			$msg = killProcess($db, $_REQUEST["processid"]);
		else
			$msg = "Select a process and click the button to kill the process";
		
		displayProcessList($db, $msg);
		//print "</div>";
		
		print "<script type=\"text/javascript\" language='javascript'> parent.updatePopupTitle('Process Manager'); </script>";
	}
	
	function displayProcessList(&$db, $msg, $type="notice")
	{
		print "<input type='hidden' name='q' value='wrkfrm' />";
		print "<input type='hidden' name='type' value='processes' />";
		print "<input type='hidden' name='id' value='' />";
		print "<input type='hidden' name='processid' value='' />";
		
		print "<table border=0 cellspacing=2 cellpadding=2 width='100%'>";
		if ($msg != "")
		{
			$icon = $type == 'warning' || $type == 'notice' ? 'ui-icon-info' : 'ui-icon-error';
			$div = '<div class="ui-widget ui-state-highlight ui-corner-all" style="padding:2px"><span class="ui-icon '.$icon.'"></span>'.$msg.'</div>';
			print "<tr><td height=\"25\">$div</td></tr>";
		}
		print "<tr><td colspan=2 valign=top>";
		
		if ($db->query("show full processlist"))
		{
			print "<table class='sortable' border=0 cellspacing=1 cellpadding=2 width='100%' id='processes'><tbody>";
			print "<tr id='fhead'><th class='th'>ID</th><th class='th'>Command</th><th class='th'>Time</th><th class='th'>Info</th></tr>";
			
			while($row = $db->fetchRow())
				print "<tr class='row' onclick=\"frmquery.processid.value='$row[Id]';\"><td class='tl'>$row[Id]</td><td class='tl'>$row[Command]</td><td class='tl'>$row[Time]</td><td class='tl'>$row[Info]</td></tr>";
			
			print "</tbody></table>";
			
			print "<tr><td colspan=2 align=right><input type='submit' name='btn' value='   Kill this process   ' onclick='document.frmquery.submit();'/></td></tr>";
			print "<script type=\"text/javascript\" language='javascript'> setupTable('processes', {sortable:true, highlight:true}); </script>";
		}
		else
			print "Failed to get process list";
	}
	
	function killProcess(&$db, $id)
	{
		if ($id)
		{
			traceMessage("killing process with id $id");
			if ($db->query("kill '$id'"))
				return ("The process with id [$_REQUEST[processid]] was killed.");
			else
				return ("No such process [id = $id]");
		}
		return "No process id provided";
	}

?>