<?php

	/********************************************************************
	*	showcreate.php - Author: Samnan ur Rehman						*
	*	This file is a part of MyWebSQL package							*
	*	PHP5 compatible													*
	*********************************************************************/

	function processRequest(&$db)
	{
		unset($_SESSION["res"]);
		unset($_SESSION["primary_key"]);
		unset($_SESSION["unique_key"]);
		unset($_SESSION["table"]);
		$_SESSION["res"] = array();
		$extraMsg = '';

		$type = $_REQUEST["id"];
		$tbl = $_REQUEST["name"];

		if ($type == "trigger")
			$sql = "show triggers where `trigger` = '$tbl'";
		else
			$sql = "show create $type `$tbl`";

		$_SESSION["query"] = $sql;
		if (!$db->query($sql))
			createErrorGrid($db);
		else
		{
			$row = $db->fetchRow();
			print "<div name='results' id='results'>";
				print "<div class='scrinfo'>";
				print "Create command for $type: $tbl<div class=\"qi\">\n";
				$cmd = ($type == "table" || $type == "view") ? $row[1] : ($type == "procedure" || $type == "function" ? $row[2] : getTriggerDefinition($row) );
				print sanitizeCreateCommand($type, $cmd);
				print "</div></div>\n";
			print "</div>\n";

			print "<script type=\"text/javascript\" language='javascript'>\n";
			print "parent.editKey = '';\n";
			print "parent.editTableName = '';";
			print ( "parent.fieldNames = new Array();\n" );
			$tm = $db->getQueryTime();
			print "parent.transferResultMessage(-1, '$tm', \"$extraMsg\");\n";
			print "parent.addCmdHistory(\"".preg_replace("/[\n\r]/", "<br/>", htmlspecialchars($sql))."\");\n";
			print "</script>";
		}
	}

	function sanitizeCreateCommand($type, $cmd)
	{
		if ($type == "table")
			return str_replace("\n", "<br>", htmlspecialchars($cmd));
		else if ($type == "view")
		{
			$str = htmlspecialchars($cmd);
			$str = str_replace(" DEFINER=", "<br>DEFINER=", $str);
			$str = str_replace(" SQL SECURITY ", "<br>SQL SECURITY ", $str);
			$str = str_replace(" AS (", "<br> AS<br>(", $str);
		}
		else if ($type == "procedure")
		{
			$str = htmlspecialchars($cmd);
			$str = str_replace(" DEFINER=", "<br>DEFINER=", $str);
			$str = str_replace(" PROCEDURE ", "<br>PROCEDURE ", $str);
			$str = str_replace("BEGIN", "<br>BEGIN<br>", $str);
			$str = str_replace(" END", "<br>END", $str);
		}
		else if ($type == "function")
		{
			$str = htmlspecialchars($cmd);
			$str = str_replace(" DEFINER=", "<br>DEFINER=", $str);
			$str = str_replace(" FUNCTION ", "<br>FUNCTION ", $str);
			$str = str_replace("BEGIN", "<br>BEGIN<br> ", $str);
			$str = str_replace(" END", "<br>END", $str);
		}
		else if ($type == "trigger")
		{
			$str = htmlspecialchars($cmd);
			$str = str_replace("\r\n", "<br/>", $str);
		}
		return $str;
	}
	
	function getTriggerDefinition($row)
	{
		$cmd = "create trigger `$row[0]`\r\n$row[4] $row[1] on $row[2]\r\nfor each row\r\n$row[3]";
		return $cmd;
	}
?>